/*
 * F_Pattern_KnockCome.xc
 *
 *  Created on: 21. nov. 2021
 *      Author: oyvindteig
 *      The last version where this is used is 0255
 */

#include <iso646.h> // not etc.
#include <xassert.h>

#include "_globals.h"
#include "F_Pattern_KnockCome.h"

KnockCome_State_e
Slave_Set_KnockCome_State // The callee TASK starts with KNOCK and later SENDS data
(
    const KnockCome_State_e PresentState,
    const KnockCome_State_e NewState
)
{
    KnockCome_State_e NextState;

    #if (DEBUG_F_PATTERN_KNOCKCOME == 1)
        //  State transition verification
        {
            bool Ok = true;

            switch (NewState)
            {
                case KC_STATE_SLAVE_SENT_KNOCK:
                {
                    Ok = (PresentState == KC_STATE_SLAVE_SENT_DATA_NOW_READY);
                } break;

                case KC_STATE_SLAVE_GOT_COME:
                {
                    Ok = (PresentState == KC_STATE_SLAVE_SENT_KNOCK);
                } break;

                case KC_STATE_SLAVE_SENT_DATA_NOW_READY:
                {
                    Ok = true; // Since ..NOW_READY
                } break;

                default:
                {
                    Ok = false;
                } break;
            }

            xassert (Ok);
        }

    #endif

    NextState = NewState;

    return NextState;
}

//  Master_Set_KnockCome_State

KnockCome_State_e
Master_Set_KnockCome_State // The callee TASK responds with COME and then RECEIVES
(
    const KnockCome_State_e PresentState,
    const KnockCome_State_e NewState
)
{
    KnockCome_State_e NextState;

    #if (DEBUG_F_PATTERN_KNOCKCOME == 1)
        //  State transition verification
        {
            bool Ok = true;

            switch (NewState)
            {
                case KC_STATE_MASTER_GOT_KNOCK:
                {
                    Ok = (PresentState == KC_STATE_MASTER_GOT_DATA_NOW_READY);
                } break;

                case KC_STATE_MASTER_SENT_COME:
                {
                    Ok = (PresentState == KC_STATE_MASTER_GOT_KNOCK);
                } break;

                case KC_STATE_MASTER_GOT_DATA_NOW_READY:
                {
                    Ok = true; // Since ..NOW_READY
                } break;

                default:
                {
                    Ok = false;
                } break;
            }

            xassert (Ok);
        }

    #endif

    NextState = NewState;

    return NextState;
}

